wf-shadow(1) "wf-shadow" "General Commands Manual"

# NAME

*wf-shadow* — An instant-replay solution for Linux-based operating systems running
a wlroots Wayland compositor

# SYNOPSIS

*wf-shadow* _OPTION_ [_OPTIONS_...]

# DESCRIPTION

*wf-shadow* is a script written in order to fill the void in instant-replay
software for Wayland, specifically wlroots compositors. It uses wf-recorder(1)
and wofi(1) in order to accomplish the task.

# OPTIONS

*-A, --acodec* _CODEC_
	This option is passed directly to ffmpeg(1)'s _-acodec_.

*-a, --audio* _DEVICE_
	This option is used in order to set the pulseaudio/pipewire-pulse device
	that is recorded by *wf-shadow*.

*-c, --vcodec* _CODEC_
	This option is passed directly to ffmpeg(1)'s _-vcodec_.

*-d, --debug*
	Sets the bash(1) _-x_ option.

*-e, --end* [_OUTPUT_]
	End the current instance running on output _OUTPUT_.

*-h, --help*
	Shows a simple help menu.

*-N, --no-video*
	By default, *wf-shadow* enables video recording.

*-n, --no-audio*
	By default, *wf-shadow* enables the -a option of wf-recorder(1). This
	option disables it.

*-R, --raw-record*
	Pass arguments directly to the record function. Somewhat like an API.

*-r, --record* [_OUTPUT_]
	Record the last few moments of video using a wofi(1) menu. Any arbitrary
	number of seconds can be input.

	This will use the same _OUTPUT_ number as any running session of
	*wf-shadow*.

*-s, --start* [_OUTPUT_]
	Starts a wf-shadow instance on output number _OUTPUT_, if no _OUTPUT_
	is specified, then use output #1.

*-V, --video* _DEVICE_
	This option is passed directly to wf-recorder(1)'s _-d_ option.

*-v, --verbose*
	Show the output of wf-recorder(1), ffmpeg(1), and wofi(1).

*-Y, --yes-video*
	Enable video recording. Overrides _-N_.

*-y, --yes-audio*
	Enable audio recording. Overrides _-n_.

*--version*
	Display version information of *wf-shadow* and its dependencies.

# ENVIRONMENT

*WF_SHADOW_DIR*
	The path to the directory used to save clips.

*WF_SHADOW_FMT*
	The date(1) _-d_ format used by *wf-shadow* to save clips.

*WF_SHADOW_EXT*
	The file extension of the saved clips. Matches the container

*WF_SHADOW_SAVE*
	The bash(1) command to run to get the save file for clips. The output of
	the command is used as the path. Overrides *WF_SHADOW_DIR*,
	*WF_SHADOW_FMT*, and *WF_SHADOW_EXT*.

*WF_SHADOW_CONFIG*
	The path to the configuration file used by *wf-shadow*.
	See *CONFIGURATION* for how to configure *wf-shadow*.

# CONFIGURATION

The configuration file takes the form of a bash(1) script. This file is sourced
after default variables are set. Use standard bash variable definitions in order
to set either environment variables found in *ENVIRONMENT*, or the following
variables.

*OUTPUT*
	The output number to use to start, end, or record on. Default is 1.

*OUTPUT_NAME*
	The name of the output to use to start, end, or record on. Unset by
	default. Overrides *OUTPUT*.

*AUDIO_DEV*
	This variable is the same as what is passed to _-a_. See *OPTIONS* for
	more information.

*AUDIO_CODEC*
	This variable is the same as what is passed to _-A_. See *OPTIONS* for
	more information.

*NO_AUDIO*
	When this variable is set, audio recording will be disabled.

*VIDEO_DEV*
	This variable is the same as what is passed to _-V_. See *OPTIONS* for
	more information.

*VIDEO_CODEC*
	This variable is the same as what is passed to _-c_. See *OPTIONS* for
	more information.

*NO_VIDEO*
	When this variable is set, video recording will be disabled in outputted
	clips.

*VERBOSE*
	This variable is non-empty if verbose output should be enabled. Same as
	_-v_.

# EXAMPLES

*wf-shadow* _-s_ _1_
	Start a *wf-shadow* session on output #1.

*wf-shadow* _-r_ _1_
	Show a wofi(1) menu of time intervals to save as a clip for the
	*wf-shadow* session on output #1. Fails if no such session exists.

*wf-shadow* _-e_ _3_
	End the *wf-shadow* session running on output #3. Fails if no such
	session exists.

*wf-shadow* _-s_ _2_ _-V_ _/dev/dri/renderD128_ _-v_
	Start a *wf-shadow* session on output #2, using /dev/dri/renderD128 as
	the video encoder. Print verbose output.

# SEE ALSO

wf-shadow-tui(1) wf-recorder(1) wofi(1) ffmpeg(1) pactl(1) date(1) bash(1)

# AUTHOR
Skylar "The Cobra" Widulski <cobra@vern.cc>
